#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <unordered_map>
#include <map>
#include <set>
#include <bitset>
#include <queue>
#include <stack>
#include <iomanip>
#include <fstream>
#include <deque>
#include <ctime>
#include <random>
#define int long long
using namespace std;
long double fp(long double ch, int st)
{
    if(st == 0)
        return 1;

    if(st == 1)
        return ch;

    if(st % 2 == 0)
    {
        long double a = fp(ch, st / 2);
        if (a * a < 1e-8)
            return 0;
        return a * a;
    }
    long double res = fp(ch, st - 1) * ch;
    if (res < 1e-8)
        return 0;
    return res;
}
main()
{
     int n, m;
    cin >> n >> m;
    vector<pair<int, long double>>v;
    long double r;
    cin >> r;
    int d;
    long double k;

    for(int i = 0; i < n; i++)
    {
        cin >> d >> k;
        v.push_back({d, k});

    }

    for(int i = 0; i < m; i++)
    {
        cin >> d;
        v.push_back({d, 1e12+7});
    }

    sort(v.begin(), v.end());
    long double otv=0;
    if(v[0].second==1e12+7)
         cout<<"0 ";
    else otv=r*v[0].second;
    for(int i=1; i<v.size(); i++)
    {
        long double ch=fp((long double)1-r, v[i].first-v[i-1].first);
        otv*=ch;
        if(v[i].second==1e12+7)
            cout<< fixed<<setprecision(10)<<otv<<" ";
        else otv+=v[i].second*r;
    }

}
